ScreenWidth = Turbine.UI.Display:GetWidth();
ScreenHeight = Turbine.UI.Display:GetHeight();
X_Coordinates = {};
Y_Coordinates = {};

if MemberCount == 1 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) + 15;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) + 35;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout3[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout3[2]);
	end	
elseif MemberCount == 2 then
	if Settings.GridLayout3[1] == 1 then
		WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) + 15;
		WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * 2 - Settings.GridDistance + 2 * 10 + 20;
	else
		WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * 2 - Settings.GridDistance + 2 * 10;
		WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) + 35;
	end
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout3[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout3[2]);
	end	
elseif MemberCount == 3 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * Settings.GridLayout3[1] - Settings.GridDistance + 2 * 10;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * Settings.GridLayout3[2] - Settings.GridDistance + 2 * 10 + 20;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout3[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout3[2]);
	end	
elseif MemberCount <= 6 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * Settings.GridLayout6[1] - Settings.GridDistance + 2 * 10;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * Settings.GridLayout6[2] - Settings.GridDistance + 2 * 10 + 20;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout6[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout6[2]);
	end	
elseif MemberCount <= 12 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * Settings.GridLayout12[1] - Settings.GridDistance + 2 * 10;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * Settings.GridLayout12[2] - Settings.GridDistance + 2 * 10 + 20;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout12[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout12[2]);
	end	
elseif MemberCount <= 18 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * Settings.GridLayout18[1] - Settings.GridDistance + 2 * 10;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * Settings.GridLayout18[2] - Settings.GridDistance + 2 * 10 + 20;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout18[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout18[2]);
	end	
elseif MemberCount <= 24 then
	WindowWidth = (Settings.MoraleBar.Width + Settings.GridDistance) * Settings.GridLayout24[1] - Settings.GridDistance + 2 * 10;
	WindowHeight = (Settings.MoraleBar.Height + Settings.GridDistance) * Settings.GridLayout24[2] - Settings.GridDistance + 2 * 10 + 20;
	for i = 1, MemberCount, 1 do
		X_Coordinates[i] = 10 + (Settings.MoraleBar.Width + Settings.GridDistance) * math.floor((i-1) / Settings.GridLayout24[2]);
		Y_Coordinates[i] = 30 + (Settings.MoraleBar.Height + Settings.GridDistance) * ((i-1) %  Settings.GridLayout24[2]);
	end	
else
	Turbine.Shell.WriteLine("[RaidHealz] Error: Invalid number of party members.");
end

-- Create Main Window
MainWindow = Turbine.UI.Window();
MainWindow:SetVisible(true);
MainWindow:SetSize(WindowWidth, WindowHeight);
MainWindow:SetBackColor(Turbine.UI.Color(0, 0.1, 0.1, 1));
	-- Show background and buttons only when MouseOver
	MainWindow.MouseEnter = function()
		MainWindow:SetBackColor(Turbine.UI.Color(0.05, 0.1, 0.1, 1))
		ReloadButton:SetVisible(true);
		SwapLockButton:SetVisible(true);
		--BuffButton:SetVisible(true);
		SettingsButton:SetVisible(true);
	end
	MainWindow.MouseLeave = function()
		MainWindow:SetBackColor(Turbine.UI.Color(0, 0.1, 0.1, 1))
		ReloadButton:SetVisible(false);
		SwapLockButton:SetVisible(false);
		--BuffButton:SetVisible(false);
		SettingsButton:SetVisible(false);
	end

-- Create Buttons
ReloadButton_X = WindowWidth - 28;
ReloadButton_Y = 9;
SettingsButton_X = WindowWidth - 50;
SettingsButton_Y = 9;
SwapLockButton_X = WindowWidth - 72;
SwapLockButton_Y = 8;
BuffButton_X = WindowWidth - 96;
BuffButton_Y = 9;

	-- Reload Button
	ReloadButton = Turbine.UI.Button();
	ReloadButton:SetParent(MainWindow);
	ReloadButton:SetPosition(ReloadButton_X, ReloadButton_Y);
	ReloadButton:SetSize(16, 16);
	ReloadButton:SetBackground(0x4111b6e6);
	ReloadButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	ReloadButton.MouseEnter = function()
		ReloadButton:SetBackground(0x4111b60e);
	end
	ReloadButton.MouseLeave = function()
		ReloadButton:SetBackground(0x4111b6e6);
	end
	ReloadButton.MouseClick = function()
		SavePositions();
		Turbine.PluginManager.LoadPlugin("RaidHealzReloader");
		Turbine.Shell.WriteLine("[RaidHealz] The plugin was reloaded.");
	end

	-- SwapLock Button
	SwapLockButtonState = true;
	SwapLockButton = Turbine.UI.Button();
	SwapLockButton:SetParent(MainWindow);
	SwapLockButton:SetPosition(SwapLockButton_X, SwapLockButton_Y);
	SwapLockButton:SetSize(20, 20);
	SwapLockButton:SetBackground(0x410001d0);
	SwapLockButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	SwapLockButton.MouseClick = function()
		if SwapLockButtonState == true then
			SwapLockButton:SetBackground(0x410001cf);
			SwapLockButtonState = false;
			for tempIndex = 1, MemberCount, 1 do
				DragControl[tempIndex]:SetVisible(true);
			end
			MainWindow:SetWantsKeyEvents(true);
			Turbine.Shell.WriteLine("[RaidHealz] You may now use Drag&Drop or the F1-F6 keys to rearrange your member positions.");
		else
			SwapLockButton:SetBackground(0x410001d0);
			SwapLockButtonState = true;
			
			for tempIndex = 1, MemberCount, 1 do
				DragControl[tempIndex]:SetVisible(false);
			end
			MainWindow:SetWantsKeyEvents(false);
			Turbine.Shell.WriteLine("[RaidHealz] Exchanging member positions is now locked.");
		end
	end
	
	-- Buff Button
	--[[BuffButton = Turbine.UI.Button();
	BuffButton:SetParent(MainWindow);
	BuffButton:SetPosition(BuffButton_X, BuffButton_Y);
	BuffButton:SetSize(16, 16);
	if BuffButtonState then
		BuffButton:SetBackground("EruadarionPlugins/RaidHealz/Resources/BuffIcon.tga");
	else
		BuffButton:SetBackground("EruadarionPlugins/RaidHealz/Resources/BuffIcon2.tga");
	end
	BuffButton.MouseClick = function()
		local tempIndex;
		local tempIndex2;
		if BuffButtonState == true then
			BuffButton:SetBackground("EruadarionPlugins/RaidHealz/Resources/BuffIcon2.tga");
			EffectWindow:SetWantsUpdates(false);
			BuffButtonState = false;
			for tempIndex = 1, MemberCount, 1 do
				for tempIndex2 = 1, 4, 1 do
					BuffControl[tempIndex][tempIndex2]:SetVisible(false);
				end
			end
			Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_Buffs", "false");
			Turbine.Shell.WriteLine("[RaidHealz] Fellowship buffs are now disabled.");
		else
			BuffButton:SetBackground("EruadarionPlugins/RaidHealz/Resources/BuffIcon.tga");
			EffectWindow:SetWantsUpdates(true);
			BuffButtonState = true;
			for tempIndex = 1, MemberCount, 1 do
				for tempIndex2 = 1, 4, 1 do
					BuffControl[tempIndex][tempIndex2]:SetVisible(true);
				end
			end
			Turbine.PluginData.Save(Turbine.DataScope.Character, "RaidHealz_Buffs", "true");
			Turbine.Shell.WriteLine("[RaidHealz] Fellowship buffs are now enabled.");
		end
	end]]
	BuffButtonState = true;
	
	-- Settings Button
	SettingsButton = Turbine.UI.Button();
	SettingsButton:SetParent(MainWindow);
	SettingsButton:SetPosition(SettingsButton_X, SettingsButton_Y);
	SettingsButton:SetSize(16, 16);
	SettingsButton:SetBackground("EruadarionPlugins/RaidHealz/Resources/SettingsIcon.tga");
	SettingsButton:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	SettingsButton.MouseClick = function()
		SettingsWindow:SetVisible(true);
	end

	-- Set buttons invisible until you MouseEnter the MainWindow
	ReloadButton:SetVisible(false);
	SwapLockButton:SetVisible(false);
	--BuffButton:SetVisible(false);
	SettingsButton:SetVisible(false);